'' +--------------------------------------------------------------------------+
'' | Cluso's P2ES-EVAL-Demo-002 for P2-ES v32i Silicon                  v0.xx |
'' +--------------------------------------------------------------------------+
'' |  Author :       (c)2013-2018 "Cluso99" (Ray Rodrick)                     |
'' |  License:       MIT License - See end of file for terms of use           |
'' +--------------------------------------------------------------------------+
'' RR20181025   001     initial demo
'' RR20181224   002     for P2 EVAL (P2-ES) pcb
'' RR20181226   003     add some monitor/debug calls
 

''============================[ CON ]============================================================
CON
  _XTALFREQ     = 20_000_000                                    ' crystal frequency
  _XDIV         = 4             '\                              '\ crystal divider                      to give 5.0MHz
  _XMUL         = 72            '| 180MHz                       '| crystal / div * mul                  to give 360MHz
  _XDIVP        = 2             '/                              '/ crystal / div * mul /divp            to give 180MHz
  _XOSC         = %01                                   'OSC    ' %00=OFF, %01=OSC, %10=15pF, %11=30pF
  _XSEL         = %11                                   'XI+PLL ' %00=rcfast(20+MHz), %01=rcslow(~20KHz), %10=XI(5ms), %11=XI+PLL(10ms)
  _XPPPP        = ((_XDIVP>>1) + 15) & $F                       ' 1->15, 2->0, 4->1, 6->2...30->14
  _CLOCKFREQ    = _XTALFREQ / _XDIV * _XMUL / _XDIVP            ' internal clock frequency                
  _SETFREQ      = 1<<24 + (_XDIV-1)<<18 + (_XMUL-1)<<8 + _XPPPP<<4 + _XOSC<<2  ' %0000_000e_dddddd_mmmmmmmmmm_pppp_cc_00  ' setup  oscillator
  _ENAFREQ      = _SETFREQ + _XSEL                                             ' %0000_000e_dddddd_mmmmmmmmmm_pppp_cc_ss  ' enable oscillator
'------------------------------------------------------------------------------------------------
  _baud         = 115_200
  _bitper       = (_clockfreq / _baud) << 16 + 7          ' 115200 baud, 8 bits
  _txmode       = %0000_0000_000_0000000000000_01_11110_0 'async tx mode, output enabled for smart output
  _rxmode       = %0000_0000_000_0000000000000_00_11111_0 'async rx mode, input  enabled for smart input
'------------------------------------------------------------------------------------------------
  rx_pin        = 63            ' pin serial receiver
  tx_pin        = 62            ' pin serial transmitter
  spi_cs        = 61            ' pin SPI memory select          (also sd_ck)
  spi_ck        = 60            ' pin SPI memory clock           (also sd_cs)
  spi_di        = 59            ' pin SPI memory data in         (also sd_di)
  spi_do        = 58            ' pin SPI memory data out        (also sd_do)
'------------------------------------------------------------------------------------------------

'' +--------------------------------------------------------------------------+
'' | Cluso's LMM_SerialDebugger for P2    (c)2013-2018 "Cluso99" (Ray Rodrick)|
'' +--------------------------------------------------------------------------+
''  xxxxxx : xx xx xx xx ... <cr>  DOWNLOAD:  to cog/lut/hub {addr1} following {byte(s)}
''  xxxxxx - [xxxxxx] [L] <cr>     LIST:      from cog/lut/hub {addr1} to < {addr2} L=longs
''  xxxxxx G <cr>                  GOTO:      to cog/lut/hub {addr1}
''  Q <cr>                         QUIT:      Quit Rom Monitor and return to the User Program
''  Lffffffff[.]xxx<cr>            LOAD:      Load file from SD
''  Rffffffff[.]xxx<cr>            RUN:       Load & Run file from SD
''  <esc><cr>                      TAQOZ:     goto TAQOZ
'' +--------------------------------------------------------------------------+
''   LMM DEBUGGER - CALL Modes...(not all modes supported)
'' +--------------------------------------------------------------------------+
  _MODE         = $F << 5                       ' mode bits defining the call b8..b5 (b4..b0 are modifier options)
  _SHIFT        = 5                             ' shr # to extract mode bits
  _HEX_         = 2 << 5                        ' hex...
    _REV_               = 1 << 4                '   - reverse byte order
    _SP                 = 1 << 3                '   - space between hex output pairs
   '_DIGITS             = 7..0 where 8->0       '   - no. of digits to display
  _LIST         = 3 << 5                        ' LIST memory line (1/4 longs) from cog/hub
    _ADDR2              = 1 << 4                ' 1= use lmm_p2 as to-address
    _LONG_              = 1 << 1                ' 1=display longs xxxxxxxx xxxxxxxx xxxxxxxx xxxxxxxx
  _TXSTRING     = 4 << 5                        ' tx string (nul terminated) from hub
  _RXSTRING     = 5 << 5                        ' rx string
    _ECHO_              = 1 << 4                '    - echo char
    _PROMPT             = 1 << 3                '    - prompt (lmm_x)
    _ADDR               = 1 << 2                '    - addr of string buffer supplied
    _NOLF               = 1 << 1                '    - strip <lf>
  _MONITOR      = 7 << 5                        ' goto rom monitor
'' +--------------------------------------------------------------------------+
''   P2 ROM SERIAL ROUTINES (HUBEXEC)
'' +--------------------------------------------------------------------------+
  _SerialInit      = $fcab8     ' Serial Initialise     (lmm_x & lmm_bufad must be set first)
  _HubTxCR         = $fcae4     ' Sends <cr><lf>        (overwrites lmm_x)
  _HubTxRev        = $fcaec     ' Sends lmm_x with bytes reversed
  _HubTx           = $fcaf0     ' Sends lmm_x           (can be up to 4 bytes)
  _HubHexRev       = $fcb24     ' Sends lmm_x with bytes reversed as Hex char(s) as defined in lmm_f
  _HubHex8         = $fcb28     ' Sends lmm_x as Hex char(s) after setting lmm_f as 8 hex chars
  _HubHex          = $fcb2c     ' Sends lmm_x as Hex char(s) as defined in lmm_f
  _HubTxStrVer     = $fcb9c     ' Sends $0 terminated string at lmm_p address after setting lmm_p=##_str_vers
  _HubTxString     = $fcba4     ' Sends $0 terminated string at lmm_p address
  _HubListA2H      = $fcbc4     ' List/Dump line(s) from lmm_p address to lmm_p2 address after setting lmm_f=#_LIST+_ADDR2 
  _HubList         = $fcbc8     ' List/Dump line(s) from lmm_p address to lmm_p2 address according to lmm_f
  _HubRx           = $fcb10     ' Recv char into lmm_x
  _HubRxStrMon     = $fccc4     ' Recv string into lmm_bufad address after setting prompt=lmm_x=#"*" & params=lmm_f=#_RXSTRING+_ECHO_+_PROMPT
  _HubRxString     = $fcccc     ' Recv string into lmm_p/lmm_bufad address according to params in lmm_f
  _HubMonitor      = $fcd78     ' Calls the Monitor; uses lmm_bufad as the input buffer address
  _RdLongCogHub    = $fcf34     ' read cog/lut/hub long from lmm_p address into lmm_x, then lmm_p++
  _str_vers        = $fd014     ' locn of hub string, $0 terminated
'' +--------------------------------------------------------------------------+
'' HUB ADDRESSES
'' +--------------------------------------------------------------------------+
  _HUBROM       = $FC000        ' ROM $FC000
  _HUBBUF       = $FC000        ' overwrite Booter
  _HUBBUFSIZE   = 80            ' RxString default size for _HUBBUF
'' +--------------------------------------------------------------------------+

''============[ COG VARIABLES $1E0-$1EF - MONITOR]=============================
''-------[ LMM parameters, etc ]-----------------------------------------------
  lmm_x         = $1e0          ' parameter passed to/from LMM routine (typically a value)
  lmm_f         = $1e1          ' parameter passed to      LMM routine (function options; returns unchanged)
  lmm_p         = $1e2          ' parameter passed to/from LMM routine (typically a hub/cog ptr/addr)
  lmm_p2        = $1e3          ' parameter passed to/from LMM routine (typically a 2nd hub/cog address)
  lmm_c         = $1e4          ' parameter passed to/from LMM routine (typically a count)
''-------[ LMM additional workareas ]------------------------------------------
  lmm_w         = $1e5          ' workarea (never saved - short term use between calls, except _HubTx)
  lmm_tx        = $1e6          ' _HubTx
  lmm_hx        = $1e7          ' _HubHex/_HubString
  lmm_hx2       = $1e8          ' _HubHex
  lmm_hc        = $1e9          '   "
  lmm_lx        = $1ea          ' _HubList
  lmm_lf        = $1eb          '   "
  lmm_lp        = $1ec          '   "
  lmm_lp2       = $1ed          '   "
  lmm_lc        = $1ee          '   "
  lmm_bufad     = $1ef          ' _HubRxString
'' +--------------------------------------------------------------------------+
'' ASCII equates
'' +--------------------------------------------------------------------------+
  _CLS_         = $0C     
  _BS_          = $08
  _LF_          = $0A
  _CR_          = $0D
  _TAQOZ_       = $1B           ' <esc>   goto TAQOZ
'' +--------------------------------------------------------------------------+

DAT
                orgh    0
                org     0
'+-------[ Set Xtal ]----------------------------------------------------------+ 
entry           hubset  #0                              ' set 20MHz+ mode
                hubset  ##_SETFREQ                      ' setup oscillator
                waitx   ##20_000_000/100                ' ~10ms
                hubset  ##_ENAFREQ                      ' enable oscillator
'+-----------------------------------------------------------------------------+
                waitx   ##_clockfreq*5                  ' just a delay to get pc terminal running

''-------[ Start Serial ]------------------------------------------------------ 
                mov     lmm_bufad,        ##_HUBBUF     ' locn of hub buffer for serial routine 
                mov     lmm_x,            ##_bitper     ' sets serial baud
                call    #_SerialInit                    ' initialise serial

''+----------------------------------------------------------------------------+
''+ Display a String (in HUB, $00 terminated)                                  +
''+----------------------------------------------------------------------------+
                mov     lmm_f,            #_TXSTRING+0  ' send string, $00 terminated (not required)
                mov     lmm_p,            ##hubstring   ' must be in hub!
                call    #_HubTxString
''-----------------------------------------------------------------------------

''+----------------------------------------------------------------------------+
''+ Dump COG memory                                                            +
''+----------------------------------------------------------------------------+
              mov       lmm_x,            ##("C" + "O"<<8 + "G"<<16)
              call      #_hubTx
              call      #_hubTxCR                       ' <cr><lf>

              mov       lmm_f,            #_LIST+_ADDR2 ' list w addr2
              mov       lmm_p,            ##$000        ' fm addr
              mov       lmm_p2,           ##$01F        ' to addr
              call      #_HubList

''+----------------------------------------------------------------------------+
              call      #_hubTxCR                       ' <cr><lf>

              mov       lmm_f,     #_LIST+_ADDR2+_LONG_ ' list w addr2 as longs
              mov       lmm_p,            ##$000        ' fm addr
              mov       lmm_p2,           ##$01F        ' to addr
              call      #_HubList

''+----------------------------------------------------------------------------+
''+ Dump LUT memory                                                            +
''+----------------------------------------------------------------------------+
              mov       lmm_x,            ##("L" + "U"<<8 + "T"<<16)
              call      #_hubTx
              call      #_hubTxCR                       ' <cr><lf>

              mov       lmm_f,            #_LIST+_ADDR2 ' list w addr2
              mov       lmm_p,            ##$200        ' fm addr
              mov       lmm_p2,           ##$21F        ' to addr
              call      #_HubList

''+----------------------------------------------------------------------------+
''+ Dump HUB memory                                                            +
''+----------------------------------------------------------------------------+
              mov       lmm_x,            ##("H" + "U"<<8 + "B"<<16)
              call      #_hubTx
              call      #_hubTxCR                       ' <cr><lf>

              mov       lmm_f,            #_LIST+_ADDR2 ' list w addr2
                                                        ' $1_xxxxx tricks to force hub :)
              mov       lmm_p,            ##$1_00000    ' fm addr
              mov       lmm_p2,           ##$1_0007F    ' to addr
              call      #_HubList
''+----------------------------------------------------------------------------+
              call      #_hubTxCR                       ' <cr><lf>

              mov       lmm_f,            #_LIST+_ADDR2 ' list w addr2
              mov       lmm_p,            ##$04000      ' fm addr
              mov       lmm_p2,           ##$0407F      ' to addr
              call      #_HubList

''---------------------------------------------------------------------------------------------------
              call      #_hubTxCR                       ' <cr><lf>
''---------------------------------------------------------------------------------------------------

''+----------------------------------------------------------------------------+
''+ Display in HEX                                                             +
''+----------------------------------------------------------------------------+
              mov       lmm_x,            ##$11223344
              mov       lmm_f,            #_HEX_        ' in hex
              call      #_hubHex
              call      #_hubTxCR                       

              mov       lmm_x,            ##$11223344
              mov       lmm_f,            #_HEX_+_SP    ' hex w spaces between bytes
              call      #_hubHex
              call      #_hubTxCR                      

              mov       lmm_x,            ##$11223344
              mov       lmm_f,            #_HEX_+_REV_  ' hex w bytes reversed
              call      #_hubHex
              call      #_hubTxCR                     

              mov       lmm_x,            ##$11223344
              mov       lmm_f,            #_HEX_+_REV_+_SP  ' hex w bytes reversed & spaces
              call      #_hubHex
              call      #_hubTxCR                      

''---------------------------------------------------------------------------------------------------
.here         jmp       #.here
''---------------------------------------------------------------------------------------------------





''============[ COG VARIABLES - MONITOR]========================================                                    
                fit     $1E0              ' ensure LMM reserved area cog $1E0-$1EF available                                                                              
''---------------------------------------------------------------------------------------------------

''============[ HUB VARIABLES ]=================================================                                    
DAT             orgh    $
hubstring       byte    "P2ES-EVAL-Demo-003",13,10
                alignl                                                                                                             
''---------------------------------------------------------------------------------------------------
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
                                                                                                             
















































  